--Script: Claustrophobia
--Usage: Slowly makes the stage collapse on itself.

local claustroEnabled = CV_RegisterVar({
	name = "claustrophobia",
	defaultvalue = 0,
	flags = CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_OnOff
})

local claustroFactor = CV_RegisterVar({
	name = "claustrophobia_factor",
	defaultvalue = FRACUNIT/5,
	flags = CV_SHOWMODIF|CV_NETVAR|CV_FLOAT,
	PossibleValue = CV_UNSIGNED
})

addHook("MapLoad",function()
	if claustroEnabled.value == 0 then
		print("\x85 Claustrophobia is off.")
	else
		print("\x83 Claustrophobia is on.")
		print("\x82(Claustrophobia) Crushing factor is " .. claustroFactor.value)
	end
end)

addHook("ThinkFrame",function()
	if claustroEnabled.value == 1 then
		for sector in sectors.iterate do
			sector.floorheight = $ + claustroFactor.value
			sector.ceilingheight = $ - claustroFactor.value
		end
	end
end)