--Script: Hyper Form
--Usage: Gives the player a Hyper form, which allows them to run even faster, jump even higher, kill anything with a poke, and abolish death timers.

--And it's VERY basic.

local hyperFormEnabled = CV_RegisterVar({
	name = "hyperform",
	defaultvalue = 0,
	flags = CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_OnOff
})

local hyperRingThres = CV_RegisterVar({
	name = "hyper_rings",
	defaultvalue = 500,
	flags = CV_SHOWMODIF|CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_UNSIGNED
})

addHook("MapLoad",function()
	if hyperFormEnabled.value == 0 then
		print("\x85Hyper Form is off.")
	else
		print("\x83Hyper Form is on.")
		print("\x82(Hyper Form) Hyper ring threshold is " .. hyperRingThres.value .. " rings")
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if hyperFormEnabled.value == 1 then
            if player.powers[pw_super] > 1 then
                if player.rings >= hyperRingThres.value then
                    if player.mo.hyper == nil then
                        player.mo.hyper = true
                    end
                    player.mo.hyper = true
                else
                    if player.mo.hyper == nil then
                        player.mo.hyper = false
                    end
                    player.mo.hyper = false
                end
            else
                if player.mo.hyper == nil then
                    player.mo.hyper = false
                end
                player.mo.hyper = false
            end
        else
            if player.mo.hyper == nil then
                player.mo.hyper = false
            end
            player.mo.hyper = false
        end
        if player.mo.hyper == true then
            player.mo.colorized = true
            player.mo.color = SKINCOLOR_WHITE
            player.mo.friction = FRACUNIT - 5000
            player.powers[pw_underwater] = 30*TICRATE
            player.powers[pw_spacetime] = 30*TICRATE
            player.mo.renderflags = $|RF_SEMIBRIGHT|RF_NOCOLORMAPS
        else
            if player.powers[pw_super] == 0 then
                player.mo.colorized = false
                player.mo.color = player.skincolor
                player.mo.friction = 59392
                player.mo.renderflags = $ & ~ (RF_SEMIBRIGHT|RF_NOCOLORMAPS)
            else
                player.mo.colorized = false
                player.mo.friction = 59392
                player.mo.renderflags = $ & ~ (RF_SEMIBRIGHT|RF_NOCOLORMAPS)
            end
        end
    end
end)

addHook("MobjMoveBlocked", function(mo,thing,line)
    for player in players.iterate do
        if mo == player.mo then
            if player.mo.hyper == true then
                if thing and thing.valid then
                    P_KillMobj(thing)
                    if line then
                        return false
                    end
                    return true
                end
            end
        end
    end
end)