--Script: Miracle Hog
--Usage: Use this script to become unkillable.

local miracleHogEnabled = CV_RegisterVar({
	name = "miraclehog",
	defaultvalue = 0,
	flags = CV_SHOWMODIF|CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_OnOff
})

addHook("MapLoad",function()
	if miracleHogEnabled.value == 0 then
		print("\x85Miracle Hog is off.")
	else
		print("\x83Miracle Hog is on.")
	end
end)

addHook("ShouldDamage", function(mo,inflictor,source,damage,damagetype)
	for player in players.iterate do
		if miracleHogEnabled.value == 1 then
			if mo == player.mo then
				if damagetype == DMG_DEATHPIT then
					P_SetObjectMomZ(player.mo,FRACUNIT*40,false)
					return false
				elseif damagetype == DMG_CRUSHED then
					player.mo.spriteyscale = FRACUNIT/3
					if player.mo.flattened == false
					or player.mo.flattened == nil
						player.height = P_GetPlayerHeight(player)/3
						S_StartSound(player.mo,708)
						player.mo.flattened = true
					end
					return false
				elseif damagetype == DMG_NUKE then
					P_InstaThrust(player.mo,InvAngle(player.mo.angle),FRACUNIT*100)
				elseif damagetype == DMG_ELECTRIC then
					player.mo.state = S_PLAY_PAIN
					player.mo.z = $ + FRACUNIT*2
					P_SetObjectMomZ(player.mo,FRACUNIT*23,false)
					S_StartSound(player.mo,675)
				elseif damagetype == DMG_FIRE then
					player.mo.z = $ + FRACUNIT*2
					if (player.cmd.buttons & BT_JUMP) then
						P_SetObjectMomZ(player.mo,FRACUNIT*25,false)
					else
						P_SetObjectMomZ(player.mo,FRACUNIT*P_RandomRange(5,13),false)
					end
					S_StartSound(player.mo,730)
					player.mo.state = S_PLAY_PAIN
					return false
				end
				if inflictor then
					if inflictor.valid then
						P_KillMobj(inflictor,mo,nil)
						if source then
							if source.valid then
								P_KillMobj(source,mo,nil)
							end
						end
					end
				end
				return false
			end
		end
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo then
			if miracleHogEnabled.value == 1 then
				player.powers[pw_underwater] = TICRATE*30
				player.powers[pw_spacetime] = TICRATE*30
			end
			if player.mo.flattened == true then
				if (player.cmd.buttons & BT_ATTACK) then
					player.mo.flattened = false
					player.mo.spriteyscale = FRACUNIT
					player.height = P_GetPlayerHeight(player)*3
					S_StartSound(player.mo,716)
					S_StartSound(player.mo,710)
				end
			end
		end
	end
end)