--Script: Ring Scale
--Usage: Makes your character change size depending on their ring count.

local RingScale = CV_RegisterVar({
	name = "ringscale",
	defaultvalue = 0,
	flags = CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_OnOff
})

local defaultRingSize = CV_RegisterVar({
	name = "default_ringsize",
	defaultvalue = 2,
	flags = CV_SHOWMODIF|CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_UNSIGNED
})

local ringSize = CV_RegisterVar({
	name = "ringsize",
	defaultvalue = 10,
	flags = CV_SHOWMODIF|CV_NETVAR|CV_CHEAT,
	PossibleValue = CV_UNSIGNED
})

addHook("MapLoad",function()
	if RingScale.value == 0 then
		print("\x85Ring Scale is off.")
	else
		print("\x83Ring Scale is on.")
		print("\x82(Ring Scale) Starting size is FRACUNIT/" .. defaultRingSize.value)
		print("\x82(Ring Scale) Ring size gain is FRACUNIT/" .. ringSize.value)
	end
end)

addHook("ThinkFrame",function()
	for player in players.iterate do
		if player.powers[pw_carry] != CR_NIGHTSMODE
		and RingScale.value == 1
			P_SetScale(player.mo, FRACUNIT/defaultRingSize.value + (FRACUNIT/ringSize.value * player.rings))
		end
	end
end)