--Script: Super Or Die
--Usage: Makes the player super, and kills them when they run out of rings.

local superordieEnabled = CV_RegisterVar({
	name = "superordie",
	defaultvalue = 0,
	flags = CV_SHOWMODIF|CV_NETVAR,
	PossibleValue = CV_OnOff
})

addHook("MapLoad",function()
	if superordieEnabled.value == 0 then
		print("\x85Super Or Die is off.")
	else
		print("\x83Super Or Die is on.")
	end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
        if superordieEnabled.value == 1 then
            if not (player.charflags & SF_SUPER) then
                player.charflags = $1 + SF_SUPER
            end
            if player.rings == 0
            and player.mo.health > 0
                P_KillMobj(player.mo)
            end
        end
    end
end)

addHook("PlayerSpawn",function(player)
    if superordieEnabled.value == 1 then
        if ultimatemode then
            player.rings = 100
        else
            player.rings = 50
        end
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD1)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD2)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD3)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD4)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD5)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD6)
        P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD7)
        player.mo.momz = 0
        player.mo.momx = 0
        player.mo.momy = 0
        player.powers[pw_super] = 1
        player.mo.state = S_PLAY_SUPER_TRANS1
    end
end)

addHook("ThinkFrame",function()
	for player in players.iterate do
		if superordieEnabled.value == 1
		and player.rings > 0
		and player.powers[pw_super] == 0
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD1)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD2)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD3)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD4)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD5)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD6)
			P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z, MT_EMERALD7)
			player.mo.momz = 0
			player.mo.momx = 0
			player.mo.momy = 0
			player.powers[pw_super] = 1
			player.mo.state = S_PLAY_SUPER_TRANS1
		end
	end
end)